Index: soft/giet_vm/giet_boot/boot.c
===================================================================
--- soft/giet_vm/giet_boot/boot.c	(revision 490)
+++ soft/giet_vm/giet_boot/boot.c	(revision 493)
@@ -875,35 +790,24 @@
 
     unsigned int procid     = _get_procid();
-    unsigned int x_cluster  = (procid >> (Y_WIDTH + P_WIDTH)) & ((1<<X_WIDTH)-1);
-    unsigned int y_cluster  = (procid >> P_WIDTH) & ((1<<Y_WIDTH)-1);
     unsigned int lpid       = procid & ((1<<P_WIDTH)-1);
 
-    if(lpid)
-    {
-        _puts("[BOOT ERROR] boot_ptabs_init() : error local processor id\n");
+    if( lpid )
+    {
+        _printf("\n[BOOT ERROR] in boot_ptab_init() : "
+                "P[%d][%d][%d] should not execute it\n", cx, cy, lpid );
         _exit();
     } 
 
-    if (header->vspaces == 0 )
-    {
-        _puts("\n[BOOT ERROR] in boot_ptabs_init() : mapping ");
-        _puts( header->name );
-        _puts(" contains no vspace\n");
+    if ( header->vspaces == 0 )
+    {
+        _printf("\n[BOOT ERROR] in boot_ptab_init() : "
+                "mapping %s contains no vspace\n", header->name );
         _exit();
     }
 
-    ///////// Phase 1 : global vsegs containing a PTAB (two loops required)
-
-#if BOOT_DEBUG_PT
-_get_lock(&lock_tty);
-_puts("\n[BOOT DEBUG] map PTAB global vsegs in cluster[");
-_putd(x_cluster);
-_puts(",");
-_putd(y_cluster);
-_puts("]");
-_puts("\n");
-_release_lock(&lock_tty);
-#endif
-
+    ///////// Phase 1 : global vseg containing the PTAB (two barriers required)
+
+    // get local PTAB vseg
+    unsigned int found = 0;
     for (vseg_id = 0; vseg_id < header->globals; vseg_id++) 
     {
@@ -912,42 +816,30 @@
         cluster = _get_cluster_base(header) + pseg->clusterid;
         if ( (vobj[vobj_id].type == VOBJ_TYPE_PTAB) && 
-             (cluster->x == x_cluster) &&
-             (cluster->y == y_cluster))
-        {
-            boot_vseg_map( &vseg[vseg_id], 0xFFFFFFFF );
-            vseg[vseg_id].mapped = 1;
-        }
-    }
-
-    _barrier_wait(&barrier_boot);
-
-    for (vseg_id = 0; vseg_id < header->globals; vseg_id++) 
-    {
-        unsigned int vobj_id = vseg[vseg_id].vobj_offset;
-        pseg    = _get_pseg_base(header) + vseg[vseg_id].psegid;
-        cluster = _get_cluster_base(header) + pseg->clusterid;
-        if ( (vobj[vobj_id].type == VOBJ_TYPE_PTAB) && 
-             (cluster->x == x_cluster) &&
-             (cluster->y == y_cluster))
-        {
-            boot_vseg_pte( &vseg[vseg_id], 0xFFFFFFFF );
-            vseg[vseg_id].mapped = 1;
-        }
-    }
-
-    _barrier_wait(&barrier_boot);
-
-    ///////// Phase 2 : global vsegs occupying more than one BPP (one loop)
-
-#if BOOT_DEBUG_PT
-_get_lock(&lock_tty);
-_puts("\n[BOOT DEBUG] map all multi-BPP global vseg in cluster[");
-_putd(x_cluster);
-_puts(",");
-_putd(y_cluster);
-_puts("]");
-_puts("\n");
-_release_lock(&lock_tty);
-#endif   
+             (cluster->x == cx) && (cluster->y == cy) )
+        {
+            found = 1;
+            break;
+        }
+    }
+    if ( found == 0 )
+    {
+        _printf("\n[BOOT ERROR] in boot_ptab_init() : "
+                "cluster[%d][%d] contains no PTAB vseg\n", cx , cy );
+        _exit();
+    }
+
+    boot_vseg_map( &vseg[vseg_id], 0xFFFFFFFF );
+
+    //////////////////////////////////////////////
+    _simple_barrier_wait( &_barrier_all_clusters );
+    //////////////////////////////////////////////
+
+    boot_vseg_pte( &vseg[vseg_id], 0xFFFFFFFF );
+
+    //////////////////////////////////////////////
+    _simple_barrier_wait( &_barrier_all_clusters );
+    //////////////////////////////////////////////
+
+    ///////// Phase 2 : global vsegs occupying more than one BPP 
 
     for (vseg_id = 0; vseg_id < header->globals; vseg_id++) 
@@ -958,60 +850,29 @@
         if ( (vobj[vobj_id].length > 0x200000) &&
              (vseg[vseg_id].mapped == 0) &&
-             (cluster->x == x_cluster) &&
-             (cluster->y == y_cluster))
+             (cluster->x == cx) && (cluster->y == cy) )
         {
             boot_vseg_map( &vseg[vseg_id], 0xFFFFFFFF );
-            vseg[vseg_id].mapped = 1;
             boot_vseg_pte( &vseg[vseg_id], 0xFFFFFFFF );
         }
     }
 
-    ///////// Phase 3 : all others global vsegs (one loop)
-
-#if BOOT_DEBUG_PT
-_get_lock(&lock_tty);
-_puts("\n[BOOT DEBUG] map all others global in cluster[ ");
-_putd(x_cluster);
-_puts(",");
-_putd(y_cluster);
-_puts("]");
-_puts("\n");
-_release_lock(&lock_tty);
-#endif
+    ///////// Phase 3 : all others global vsegs 
 
     for (vseg_id = 0; vseg_id < header->globals; vseg_id++) 
-    {
-        unsigned int vobj_id = vseg[vseg_id].vobj_offset;
+    { 
         pseg    = _get_pseg_base(header) + vseg[vseg_id].psegid;
         cluster = _get_cluster_base(header) + pseg->clusterid;
-        if ( (vobj[vobj_id].length <= 0x200000) &&
-             (vseg[vseg_id].mapped == 0) && 
-             (cluster->x == x_cluster) &&
-             (cluster->y == y_cluster))
+        if ( (vseg[vseg_id].mapped == 0) && 
+             (cluster->x == cx) && (cluster->y == cy) )
         {
             boot_vseg_map( &vseg[vseg_id], 0xFFFFFFFF );
-            vseg[vseg_id].mapped = 1;
             boot_vseg_pte( &vseg[vseg_id], 0xFFFFFFFF );
         }
     }
 
-    ///////// Phase 4 : all private vsegs (two nested loops)
+    ///////// Phase 4 : all private vsegs 
 
     for (vspace_id = 0; vspace_id < header->vspaces; vspace_id++) 
     {
-
-#if BOOT_DEBUG_PT
-_get_lock(&lock_tty);
-_puts("\n[BOOT DEBUG] map private vsegs for vspace ");
-_puts( vspace[vspace_id].name );
-_puts(" in cluster[ ");
-_putd(x_cluster);
-_puts(",");
-_putd(y_cluster);
-_puts("]");
-_puts("\n");
-_release_lock(&lock_tty);
-#endif
-
         for (vseg_id = vspace[vspace_id].vseg_offset;
              vseg_id < (vspace[vspace_id].vseg_offset + vspace[vspace_id].vsegs);
@@ -1020,10 +881,7 @@
             pseg    = _get_pseg_base(header) + vseg[vseg_id].psegid;
             cluster = _get_cluster_base(header) + pseg->clusterid;
-            if((vseg[vseg_id].mapped == 0) && 
-               (cluster->x == x_cluster) &&
-               (cluster->y == y_cluster))
+            if ( (cluster->x == cx) && (cluster->y == cy) )
             {
                 boot_vseg_map( &vseg[vseg_id], vspace_id );
-                vseg[vseg_id].mapped = 1;
                 boot_vseg_pte( &vseg[vseg_id], vspace_id );
             }
@@ -1031,89 +889,34 @@
     }
 
-#if (BOOT_DEBUG_PT > 2) 
-_get_lock(&lock_tty);
-mapping_vseg_t*    curr;
-mapping_pseg_t*    pseg    = _get_pseg_base(header);
-mapping_cluster_t* cluster = _get_cluster_base(header);
-unsigned int       pseg_id;
-for( pseg_id = 0 ; pseg_id < header->psegs ; pseg_id++ )
+    //////////////////////////////////////////////
+    _simple_barrier_wait( &_barrier_all_clusters );
+    //////////////////////////////////////////////
+
+} // end boot_ptab_init()
+
+////////////////////////////////////////////////////////////////////////////////
+// This function should be executed by P[0][0][0] only. It complete the
+// page table initialisation, taking care of all global vsegs that are
+// not mapped in a cluster containing a processor, and have not been
+// handled by the boot_ptab_init(x,y) function.
+// An example of such vsegs are the external peripherals in TSAR_LETI platform.
+////////////////////////////////////////////////////////////////////////////////
+void boot_ptab_extend()
 {
-    unsigned int cluster_id = pseg[pseg_id].clusterid;
-    _puts("\n[BOOT DEBUG] vsegs mapped on pseg ");
-    _puts( pseg[pseg_id].name );
-    _puts(" in cluster[");
-    _putd( cluster[cluster_id].x );
-    _puts(",");
-    _putd( cluster[cluster_id].y );
-    _puts("]\n");
-    for( curr = (mapping_vseg_t*)pseg[pseg_id].next_vseg ;
-         curr != 0 ;
-         curr = (mapping_vseg_t*)curr->next_vseg )
-    {
-        _puts(" - vseg ");
-        _puts( curr->name );
-        _puts(" : len = ");
-        _putx( curr->length );
-        _puts(" / vbase ");
-        _putx( curr->vbase );
-        _puts(" / pbase ");
-        _putl( curr->pbase );
-        _puts("\n");
-    }  
-}
-_release_lock(&lock_tty);
-#endif
-
-} // end boot_ptabs_init()
-
-///////////////////////////////////////////////////////////////////////////////
-// This function initializes the private vobjs that have the CONST type.
-// The MMU is supposed to be activated...
-///////////////////////////////////////////////////////////////////////////////
-void boot_vobjs_init() 
-{
-    mapping_header_t* header = (mapping_header_t *)SEG_BOOT_MAPPING_BASE;
-    mapping_vspace_t* vspace = _get_vspace_base(header);
-    mapping_vobj_t* vobj     = _get_vobj_base(header);
-
-    unsigned int vspace_id;
-    unsigned int vobj_id;
-
-    // loop on the vspaces
-    for (vspace_id = 0; vspace_id < header->vspaces; vspace_id++) 
-    {
-
-#if BOOT_DEBUG_VOBJS
-_puts("\n[BOOT DEBUG] ****** vobjs initialisation in vspace ");
-_puts(vspace[vspace_id].name);
-_puts(" ******\n");
-#endif
-
-        _set_mmu_ptpr( (unsigned int)(_ptabs_paddr[vspace_id][0][0] >> 13) );
-
-        // loop on the vobjs
-        for (vobj_id = vspace[vspace_id].vobj_offset;
-             vobj_id < (vspace[vspace_id].vobj_offset + vspace[vspace_id].vobjs);
-             vobj_id++) 
-        {
-            if ( (vobj[vobj_id].type) == VOBJ_TYPE_CONST )
-            {
-#if BOOT_DEBUG_VOBJS
-_puts("CONST   : ");
-_puts(vobj[vobj_id].name);
-_puts(" / vaddr  = ");
-_putx(vobj[vobj_id].vaddr);
-_puts(" / paddr  = ");
-_putl(vobj[vobj_id].paddr);
-_puts(" / value  = ");
-_putx(vobj[vobj_id].init);
-_puts("\n");
-#endif
-                unsigned int* addr = (unsigned int *) vobj[vobj_id].vbase;
-                *addr = vobj[vobj_id].init;
-            }
-        }
-    }
-} // end boot_vobjs_init()
+
+    mapping_header_t*   header = (mapping_header_t *)SEG_BOOT_MAPPING_BASE;
+    mapping_vseg_t*     vseg   = _get_vseg_base(header);
+
+    unsigned int vseg_id;
+
+    for (vseg_id = 0; vseg_id < header->globals; vseg_id++) 
+    {
+        if ( vseg[vseg_id].mapped == 0 )  
+        {
+            boot_vseg_map( &vseg[vseg_id], 0xFFFFFFFF );
+            boot_vseg_pte( &vseg[vseg_id], 0xFFFFFFFF );
+        }
+    }
+}  // end boot_ptab_extend()
 
 ///////////////////////////////////////////////////////////////////////////////
@@ -1147,9 +950,6 @@
     {
         mapping_cluster_t* cluster = _get_cluster_base(header);
-        _puts("\n[BOOT ERROR] No vobj of type SCHED in cluster [");
-        _putd( cluster[cluster_id].x );
-        _puts(",");
-        _putd( cluster[cluster_id].y );
-        _puts("]\n");
+        _printf("\n[BOOT ERROR] No vobj of type SCHED in cluster [%d,%d]\n",
+                cluster[cluster_id].x, cluster[cluster_id].y );
         _exit();
     }
@@ -1157,355 +957,151 @@
 
 ////////////////////////////////////////////////////////////////////////////////////
-// This function initialises all processors schedulers.
-// This is done by processor 0, and the MMU must be activated.
-// - In Step 1, it initialises the _schedulers[x][y][l] pointers array, and scan
-//              the processors for a first initialisation of the schedulers:
-//              idle_task context, and HWI / SWI / PTI vectors. 
+// This function is executed in parallel by all processors P[x][y][0].
+// It initialises all schedulers in cluster [x][y]. The MMU must be activated.
+// It is split in two phases separated by a synchronisation barrier.
+// - In Step 1, it initialises the _schedulers[x][y][l] pointers array,
+//              the idle_task context and the HWI / PTI vectors. 
 // - In Step 2, it scan all tasks in all vspaces to complete the tasks contexts, 
-//              initialisation as specified in the mapping_info data structure. 
+//              initialisation as specified in the mapping_info data structure,
+//              and set the CP0_SCHED register. 
 ////////////////////////////////////////////////////////////////////////////////////
-void boot_schedulers_init() 
+void boot_scheduler_init( unsigned int x, 
+                          unsigned int y )
 {
-    mapping_header_t*  header  = (mapping_header_t *)SEG_BOOT_MAPPING_BASE;
-    mapping_cluster_t* cluster = _get_cluster_base(header);
-    mapping_vspace_t*  vspace  = _get_vspace_base(header);
-    mapping_task_t*    task    = _get_task_base(header);
-    mapping_vobj_t*    vobj    = _get_vobj_base(header);
-    mapping_periph_t*  periph  = _get_periph_base(header);
-    mapping_irq_t*     irq     = _get_irq_base(header);
-
-    unsigned int cluster_id;    // cluster index in mapping_info 
-    unsigned int periph_id;     // peripheral index in mapping_info
-    unsigned int irq_id;        // irq index in mapping_info
-    unsigned int vspace_id;     // vspace index in mapping_info
-    unsigned int task_id;       // task index in mapping_info
-    unsigned int vobj_id;       // vobj index in mapping_info
-
-    unsigned int lpid;          // local processor index (for several loops)
-
-    // WTI allocators to processors (for HWIs translated to WTIs)  
-    // In all clusters the first NB_PROCS_MAX WTIs are reserved for WAKUP
-    unsigned int alloc_wti_channel[X_SIZE*Y_SIZE];   // one per cluster
-
-    // pointers on the XCU and PIC peripherals
+    mapping_header_t*    header  = (mapping_header_t *)SEG_BOOT_MAPPING_BASE;
+    mapping_cluster_t*   cluster = _get_cluster_base(header);
+    mapping_vspace_t*    vspace  = _get_vspace_base(header);
+    mapping_task_t*      task    = _get_task_base(header);
+    mapping_vobj_t*      vobj    = _get_vobj_base(header);
+    mapping_periph_t*    periph  = _get_periph_base(header);
+    mapping_irq_t*       irq     = _get_irq_base(header);
+
+    unsigned int         periph_id; 
+    unsigned int         irq_id;
+    unsigned int         vspace_id;
+    unsigned int         task_id; 
+    unsigned int         vobj_id; 
+
+    unsigned int         sched_vbase;          // schedulers array vbase address 
+    unsigned int         sched_length;         // schedulers array length
+    static_scheduler_t*  psched;               // pointer on processor scheduler
+
+    unsigned int cluster_id = x * Y_SIZE + y;  
+    unsigned int nprocs = cluster[cluster_id].procs;
+    unsigned int lpid;                       
+    
+    /////////////////////////////////////////////////////////////////////////
+    // Step 1 : initialize the schedulers[] array of pointers,
+    //          the idle task context and the HWI and PTI interrupt vectors.
+    //          The WTI interrupt vector entries corresponding to interrupts
+    //          generated by the PIC component are handled later.
+
+    // get scheduler array virtual base address in cluster[x,y]
+    boot_get_sched_vaddr( cluster_id, &sched_vbase, &sched_length );
+
+    if ( sched_length < (nprocs<<13) ) // 8 Kbytes per scheduler
+    {
+        _printf("\n[BOOT ERROR] Sched segment too small in cluster[%d,%d]\n", x, y );
+        _exit();
+    }
+
+    // loop on local processors
+    for ( lpid = 0 ; lpid < nprocs ; lpid++ )
+    {
+        // get scheduler pointer and initialise the schedulers pointers array
+        psched = (static_scheduler_t*)(sched_vbase + (lpid<<13));
+        _schedulers[x][y][lpid] = psched;
+
+        // initialise the "tasks" and "current" variables default values
+        psched->tasks   = 0;
+        psched->current = IDLE_TASK_INDEX;
+
+        // default values for HWI / PTI / SWI vectors (valid bit = 0)
+        unsigned int slot;
+        for (slot = 0; slot < 32; slot++)
+        {
+            psched->hwi_vector[slot] = 0;
+            psched->pti_vector[slot] = 0;
+            psched->wti_vector[slot] = 0;
+        }
+
+        // WTI[lpid] <= ISR_WAKUP / PTI[lpid] <= ISR_TICK 
+        psched->wti_vector[lpid] = ISR_WAKUP | 0x80000000;
+        psched->pti_vector[lpid] = ISR_TICK  | 0x80000000;
+
+        // initializes the idle_task context:
+        // - the SR slot is 0xFF03 because this task run in kernel mode.
+        // - it uses the page table of vspace[0]
+        // - it uses the kernel TTY terminal
+        // - slots containing addresses (SP,RA,EPC) are initialised by kernel_init()
+
+        psched->context[IDLE_TASK_INDEX][CTX_CR_ID]   = 0;
+        psched->context[IDLE_TASK_INDEX][CTX_SR_ID]   = 0xFF03;
+        psched->context[IDLE_TASK_INDEX][CTX_PTPR_ID] = _ptabs_paddr[0][x][y]>>13;
+        psched->context[IDLE_TASK_INDEX][CTX_PTAB_ID] = _ptabs_vaddr[0][x][y];
+        psched->context[IDLE_TASK_INDEX][CTX_TTY_ID]  = 0;
+        psched->context[IDLE_TASK_INDEX][CTX_LTID_ID] = IDLE_TASK_INDEX;
+        psched->context[IDLE_TASK_INDEX][CTX_VSID_ID] = 0;
+        psched->context[IDLE_TASK_INDEX][CTX_RUN_ID]  = 1;
+    }
+
+    // scan local peripherals to get local XCU 
     mapping_periph_t*  xcu = NULL;
-    mapping_periph_t*  pic = NULL;
-
-    unsigned int          sched_vbase;  // schedulers array vbase address in a cluster
-    unsigned int          sched_length; // schedulers array length
-    static_scheduler_t*   psched;       // pointer on processor scheduler
-
-    /////////////////////////////////////////////////////////////////////////
-    // Step 1 : loop on the clusters and on the processors 
-    //          to initialize the schedulers[] array of pointers,
-    //          idle task context and interrupt vectors.
-    // Implementation note:
-    // We need to use both (proc_id) to scan the mapping info structure,
-    // and (x,y,lpid) to access the schedulers array.
-
-    for (cluster_id = 0 ; cluster_id < X_SIZE*Y_SIZE ; cluster_id++) 
-    {
-        unsigned int x          = cluster[cluster_id].x;
-        unsigned int y          = cluster[cluster_id].y;
-
-#if BOOT_DEBUG_SCHED
-_puts("\n[BOOT DEBUG] Initialise schedulers in cluster[");
-_putd( x );
-_puts(",");
-_putd( y );
-_puts("]\n");
-#endif
-        alloc_wti_channel[cluster_id] = NB_PROCS_MAX;
-
-        // checking processors number
-        if ( cluster[cluster_id].procs > NB_PROCS_MAX )
-        {
-            _puts("\n[BOOT ERROR] Too much processors in cluster[");
-            _putd( x );
-            _puts(",");
-            _putd( y );
-            _puts("]\n");
-            _exit();
-        }
- 
-        // no schedulers initialisation if nprocs == 0
-        if ( cluster[cluster_id].procs > 0 )
-        {
-            // get scheduler array virtual base address in cluster[cluster_id]
-            boot_get_sched_vaddr( cluster_id, &sched_vbase, &sched_length );
-
-            if ( sched_length < (cluster[cluster_id].procs<<13) ) // 8 Kbytes per scheduler
+
+    for ( periph_id = cluster[cluster_id].periph_offset ;
+          periph_id < cluster[cluster_id].periph_offset + cluster[cluster_id].periphs;
+          periph_id++ )
+    {
+        if( periph[periph_id].type == PERIPH_TYPE_XCU ) 
+        {
+            xcu = &periph[periph_id];
+
+            if ( xcu->arg < (nprocs * header->irq_per_proc) )
             {
-                _puts("\n[BOOT ERROR] Schedulers segment too small in cluster[");
-                _putd( x );
-                _puts(",");
-                _putd( y );
-                _puts("]\n");
+                _printf("\n[BOOT ERROR] Not enough inputs for XCU[%d,%d]\n", x, y );
                 _exit();
             }
-
-            // scan peripherals to find the XCU and the PIC component
-
-            xcu = NULL;  
-            for ( periph_id = cluster[cluster_id].periph_offset ;
-                  periph_id < cluster[cluster_id].periph_offset + cluster[cluster_id].periphs;
-                  periph_id++ )
-            {
-                if( periph[periph_id].type == PERIPH_TYPE_XCU ) 
-                {
-                    xcu = &periph[periph_id];
-
-                    if ( xcu->arg < cluster[cluster_id].procs )
-                    {
-                        _puts("\n[BOOT ERROR] Not enough inputs for XCU[");
-                        _putd( x );
-                        _puts(",");
-                        _putd( y );
-                        _puts("]\n");
-                        _exit();
-                    }
-                }
-                if( periph[periph_id].type == PERIPH_TYPE_PIC )   
-                {
-                    pic = &periph[periph_id];
-                }
-            } 
-            if ( xcu == NULL )
-            {         
-                _puts("\n[BOOT ERROR] No XCU component in cluster[");
-                _putd( x );
-                _puts(",");
-                _putd( y );
-                _puts("]\n");
-                _exit();
-            }
-
-            // loop on processors for schedulers default values
-            // initialisation, including WTI and PTI vectors
-            for ( lpid = 0 ; lpid < cluster[cluster_id].procs ; lpid++ )
-            {
-                // pointer on processor scheduler
-                psched = (static_scheduler_t*)(sched_vbase + (lpid<<13));
-
-                // initialise the schedulers pointers array
-                _schedulers[x][y][lpid] = psched;
-
-#if BOOT_DEBUG_SCHED
-unsigned int   sched_vbase = (unsigned int)_schedulers[x][y][lpid];
-unsigned int   sched_ppn;
-unsigned int   sched_flags;
-paddr_t        sched_pbase;
-
-page_table_t* ptab = (page_table_t*)(_ptabs_vaddr[0][x][y]);
-_v2p_translate( ptab, sched_vbase>>12, &sched_ppn, &sched_flags );
-sched_pbase = ((paddr_t)sched_ppn)<<12;
-
-_puts("\nProc[");
-_putd( x );
-_puts(",");
-_putd( y );
-_puts(",");
-_putd( lpid );
-_puts("] : scheduler vbase = ");
-_putx( sched_vbase );
-_puts(" : scheduler pbase = ");
-_putl( sched_pbase );
-_puts("\n");
-#endif
-                // initialise the "tasks" and "current" variables default values
-                psched->tasks   = 0;
-                psched->current = IDLE_TASK_INDEX;
-
-                // default values for HWI / PTI / SWI vectors (valid bit = 0)
-                unsigned int slot;
-                for (slot = 0; slot < 32; slot++)
-                {
-                    psched->hwi_vector[slot] = 0;
-                    psched->pti_vector[slot] = 0;
-                    psched->wti_vector[slot] = 0;
-                }
-
-                // WTI[lpid] <= ISR_WAKUP / PTI[lpid] <= ISR_TICK 
-                psched->wti_vector[lpid] = ISR_WAKUP | 0x80000000;
-                psched->pti_vector[lpid] = ISR_TICK  | 0x80000000;
-
-                // initializes the idle_task context in scheduler:
-                // - the SR slot is 0xFF03 because this task run in kernel mode.
-                // - it uses the page table of vspace[0]
-                // - it uses the kernel TTY terminal
-                // - slots containing addresses (SP, RA, EPC)
-                //   must be initialised by kernel_init()
-
-                psched->context[IDLE_TASK_INDEX][CTX_CR_ID]   = 0;
-                psched->context[IDLE_TASK_INDEX][CTX_SR_ID]   = 0xFF03;
-                psched->context[IDLE_TASK_INDEX][CTX_PTPR_ID] = _ptabs_paddr[0][x][y]>>13;
-                psched->context[IDLE_TASK_INDEX][CTX_PTAB_ID] = _ptabs_vaddr[0][x][y];
-                psched->context[IDLE_TASK_INDEX][CTX_TTY_ID]  = 0;
-                psched->context[IDLE_TASK_INDEX][CTX_LTID_ID] = IDLE_TASK_INDEX;
-                psched->context[IDLE_TASK_INDEX][CTX_VSID_ID] = 0;
-                psched->context[IDLE_TASK_INDEX][CTX_RUN_ID]  = 1;
-
-            }  // end for processors
-
-            // scan HWIs connected to local XCU 
-            // for round-robin allocation to processors
-            lpid = 0;
-            for ( irq_id = xcu->irq_offset ;
-                  irq_id < xcu->irq_offset + xcu->irqs ;
-                  irq_id++ )
-            {
-                unsigned int type    = irq[irq_id].srctype;
-                unsigned int srcid   = irq[irq_id].srcid;
-                unsigned int isr     = irq[irq_id].isr & 0xFFFF;
-                unsigned int channel = irq[irq_id].channel << 16;
-
-                if ( (type != IRQ_TYPE_HWI) || (srcid > 31) )
-                {
-                    _puts("\n[BOOT ERROR] Bad IRQ in XCU of cluster[");
-                    _putd( x );
-                    _puts(",");
-                    _putd( y );
-                    _puts("]\n");
-                    _exit();
-                }
-
-                _schedulers[x][y][lpid]->hwi_vector[srcid] = isr | channel | 0x80000000;
-                lpid = (lpid + 1) % cluster[cluster_id].procs; 
-
-            } // end for irqs
-        } // end if nprocs > 0
-    } // end for clusters
-
-    // If there is an external PIC component, we scan HWIs connected to PIC
-    // for Round Robin allocation (as WTI) to processors.
-    // We allocate one WTI per processor, starting from proc[0,0,0], 
-    // and we increment (cluster_id, lpid) as required.
-    if ( pic != NULL )
-    {   
-        unsigned int cluster_id = 0;   // index in clusters array
-        unsigned int lpid       = 0;   // processor local index
-
-        // scan IRQS defined in PIC
-        for ( irq_id = pic->irq_offset ;
-              irq_id < pic->irq_offset + pic->irqs ;
-              irq_id++ )
-        {
-            // compute next values for (cluster_id,lpid)
-            // if no more procesor available in current cluster
-            unsigned int overflow = 0;
-            while ( (lpid >= cluster[cluster_id].procs) ||
-                    (alloc_wti_channel[cluster_id] >= xcu->arg) )
-            {
-                overflow++;
-                cluster_id = (cluster_id + 1) % (X_SIZE*Y_SIZE);
-                lpid       = 0;
-
-                // overflow detection
-                if ( overflow > (X_SIZE*Y_SIZE*NB_PROCS_MAX*32) )
-                {
-                    _puts("\n[BOOT ERROR] Not enough processors for external IRQs\n");
-                    _exit();
-                }
-            } // end while
-
-            unsigned int type    = irq[irq_id].srctype;
-            unsigned int srcid   = irq[irq_id].srcid;
-            unsigned int isr     = irq[irq_id].isr & 0xFFFF;
-            unsigned int channel = irq[irq_id].channel << 16;
-
-            if ( (type != IRQ_TYPE_HWI) || (srcid > 31) )
-            {
-                _puts("\n[BOOT ERROR] Bad IRQ in PIC component\n");
-                _exit();
-            }
-
-            // get scheduler[cluster_id] address
-            unsigned int x          = cluster[cluster_id].x;
-            unsigned int y          = cluster[cluster_id].y;
-            unsigned int cluster_xy = (x<<Y_WIDTH) + y;
-            psched                  = _schedulers[x][y][lpid];
-
-            // update WTI vector for scheduler[cluster_id][lpid]
-            unsigned int index            = alloc_wti_channel[cluster_id];
-            psched->wti_vector[index]     = isr | channel | 0x80000000;
-
-            // increment pointers
-            alloc_wti_channel[cluster_id] = index + 1;
-            lpid                          = lpid + 1;
-
-            // update IRQ fields in mapping for PIC initialisation
-            irq[irq_id].dest_id = index;
-            irq[irq_id].dest_xy = cluster_xy;
-
-        }  // end for IRQs
-    } // end if PIC
-                
-#if BOOT_DEBUG_SCHED
-for ( cluster_id = 0 ; cluster_id < (X_SIZE*Y_SIZE) ; cluster_id++ )
-{
-    unsigned int x          = cluster[cluster_id].x;
-    unsigned int y          = cluster[cluster_id].y;
-    unsigned int slot;
-    unsigned int entry;
-    for ( lpid = 0 ; lpid < cluster[cluster_id].procs ; lpid++ )
-    {
-        psched = _schedulers[x][y][lpid];
-        
-        _puts("\n*** IRQS for proc[");
-        _putd( x );
-        _puts(",");
-        _putd( y );
-        _puts(",");
-        _putd( lpid );
-        _puts("]\n");
-        for ( slot = 0 ; slot < 32 ; slot++ )
-        {
-            entry = psched->hwi_vector[slot];
-            if ( entry & 0x80000000 ) 
-            {
-                _puts(" - HWI ");
-                _putd( slot );
-                _puts(" / isrtype = ");
-                _putd( entry & 0xFFFF ); 
-                _puts(" / channel = ");
-                _putd( (entry >> 16) & 0x7FFF ); 
-                _puts("\n");
-            }
-        }
-        for ( slot = 0 ; slot < 32 ; slot++ )
-        {
-            entry = psched->wti_vector[slot];
-            if ( entry & 0x80000000 ) 
-            {
-                _puts(" - WTI ");
-                _putd( slot );
-                _puts(" / isrtype = ");
-                _putd( entry & 0xFFFF ); 
-                _puts(" / channel = ");
-                _putd( (entry >> 16) & 0x7FFF ); 
-                _puts("\n");
-            }
-        }
-        for ( slot = 0 ; slot < 32 ; slot++ )
-        {
-            entry = psched->pti_vector[slot];
-            if ( entry & 0x80000000 ) 
-            {
-                _puts(" - PTI ");
-                _putd( slot );
-                _puts(" / isrtype = ");
-                _putd( entry & 0xFFFF ); 
-                _puts(" / channel = ");
-                _putd( (entry >> 16) & 0x7FFF ); 
-                _puts("\n");
-            }
-        }
-    }
-}
-#endif
-
-    ///////////////////////////////////////////////////////////////////
-    // Step 2 : loop on the vspaces and the tasks  to complete
-    //          the schedulers and task contexts initialisation.
+        }
+    } 
+
+    if ( xcu == NULL )
+    {         
+        _printf("\n[BOOT ERROR] missing XCU in cluster[%d,%d]\n", x , y );
+        _exit();
+    }
+
+    // scan HWIs connected to local XCU 
+    // for round-robin allocation to local processors
+    lpid = 0;
+    for ( irq_id = xcu->irq_offset ;
+          irq_id < xcu->irq_offset + xcu->irqs ;
+          irq_id++ )
+    {
+        unsigned int type    = irq[irq_id].srctype;
+        unsigned int srcid   = irq[irq_id].srcid;
+        unsigned int isr     = irq[irq_id].isr & 0xFFFF;
+        unsigned int channel = irq[irq_id].channel << 16;
+
+        if ( (type != IRQ_TYPE_HWI) || (srcid > 31) )
+        {
+            _printf("\n[BOOT ERROR] Bad IRQ in cluster[%d,%d]\n", x, y );
+            _exit();
+        }
+
+        _schedulers[x][y][lpid]->hwi_vector[srcid] = isr | channel | 0x80000000;
+
+        lpid = (lpid + 1) % nprocs; 
+    } // end for irqs
+
+    //////////////////////////////////////////////
+    _simple_barrier_wait( &_barrier_all_clusters );
+    //////////////////////////////////////////////
+
+    ////////////////////////////////////////////////////////////////////////
+    // Step 2 : Initialise the tasks context. The context of task placed
+    //          on  processor P must be stored in the scheduler of P.
+    //          This require two nested loops: loop on the tasks, and loop 
+    //          on the local processors. We complete the scheduler when the
+    //          required placement fit one local processor.
 
     for (vspace_id = 0; vspace_id < header->vspaces; vspace_id++) 
@@ -1513,5 +1109,5 @@
         // We must set the PTPR depending on the vspace, because the start_vector 
         // and the stack address are defined in virtual space.
-        _set_mmu_ptpr( (unsigned int)(_ptabs_paddr[vspace_id][0][0] >> 13) );
+        _set_mmu_ptpr( (unsigned int)(_ptabs_paddr[vspace_id][x][y] >> 13) );
 
         // loop on the tasks in vspace (task_id is the global index in mapping)
